* AsyncDemoMain.PRG
* Created by J. Randy Pearson and modified by Barbara Peisch

#INCLUDE WCONNECT.H

PARAMETERS lcJobId

IF EMPTY( m.lcJobId)
  RETURN
ENDIF
SET EXCLUSIVE OFF
SET TALK OFF
SET SAFETY OFF

ON ERROR do AsyncError with ;
		ERROR(), MESSAGE(), MESSAGE(1), SYS(16), LINENO()

DO wconnect
SET PROCEDURE TO wwasyncwebrequest ADDITIVE

DO PATH WITH '.\Data'

LOCAL loAsync, lcTitle
loAsync = CREATEOBJECT( "wwAsyncWebRequest")

IF NOT loAsync.LoadEvent( m.lcJobId)
  ON ERROR
  RETURN
ENDIF

loAsync.oEvent.Started = DATETIME()
loAsync.SaveEvent()

lcTitle = TRIM( loAsync.oEvent.Title)
DO CASE
CASE lcTitle == "Slow Task"
  DelayEvent( loAsync, m.lcJobId, 20)
  LOCAL lcResult

  m.lcResult = "Here are your results"
  loAsync.CompleteEvent( m.lcJobId, m.lcResult)
ENDCASE

ON ERROR

RETURN

ENDFUNC 
* ----------------------------------------------------- *
FUNCTION AsyncError( lnErr, lcMess, lcCode, lcMethod, lnLine)
	ON ERROR
	WAIT WINDOW TIMEOUT 2 m.lcMess + [ (error ] + TRANS( m.lnErr) + [)]
	IF NOT FILE( FULLPATH( ".\AsyncError.DBF"))
	  SELECT 0
	  CREATE TABLE AsyncError FREE ;
	    ( Error I, Message C(80), Code M, Method C(50), Line I, MoreInfo M)
	  USE
	ENDIF
	LOCAL lcLogString, lnLevel, lnPtr

	lnLevel = PROGRAM(-1)
	lcLogString = ""
	lcLogString = m.lcLogString + "Program Stack" + CRLF + CRLF
	FOR lnPtr = lnLevel TO 1 STEP -1
	  lcLogString = m.lcLogString + ;
	    TRANS( m.lnPtr) + [. ] + PROGRAM( m.lnPtr) + CRLF
	ENDFOR
	INSERT INTO AsyncError ;
	    ( Error, Message, Code, Method, Line, MoreInfo) ;
	    VALUES ;
	    ( lnErr, lcMess, lcCode, lcMethod, lnLine, lcLogString )
ENDFUNC  && AsyncError
* ----------------------------------------------------- *
FUNCTION DelayEvent( loAsync, lcId, lnSecs)
	DECLARE Sleep IN WIN32API INTEGER
	LOCAL ii
	FOR ii = 1 TO m.lnSecs
	  Sleep( 1000)
	  IF NOT loAsync.LoadEvent( m.lcID)  
	     LOOP
	  ENDIF
	  IF loAsync.oEvent.Cancelled
	     RETURN 
	  ENDIF
	  loAsync.oEvent.Status = TRANS( m.lnSecs - m.ii) + " seconds remaining."
	  loAsync.SaveEvent()
	ENDFOR  
ENDFUNC  && DelayEvent
* ----------------------------------------------------- *
