SET PROCEDURE TO wwAsyncWebRequest ADDITIVE  && not yet set in WCONNECT.PRG
LOCAL loAsync, lcAction, lcJobId, lnRefreshPeriod, lnRetries, lnTry, lcMessage

loAsync = CREATEOBJECT( "wwAsyncWebRequest")
* See if this is a new request or polling for a current request:
lcAction = Request.QueryString( 'Action')
lcAction = IIF( EMPTY( m.lcAction), 'New', PROPER( m.lcAction))
IF m.lcAction == 'New'
	lcJobId = loAsync.SubmitEvent( , "Slow Task")
	* Optionally, fire up the process here. (Note: You
	* can also run a continuous background process that
	* polls for new requests.)
	LOCAL lcRunCmd
	lcRunCmd = [RUN /4 AsyncHandler.exe ] + m.lcJobId
	&lcRunCmd
ELSE  && not new
	lcJobId = Request.QueryString( 'JobId') 
ENDIF

* Set refresh periond (in seconds):
lnRefreshPeriod = 1
* How many polls before we give up:
lnRetries = 30
* Which retry are we on:
lnTry = 0
  
DO CASE
CASE m.lcAction == 'Check'
	LOCAL lnStatus
	lnStatus = loAsync.CheckForCompletion( m.lcJobId)
	* 0 means still running, negative numbers are bad news
	DO CASE
	CASE m.lnStatus = -2  && bad ID
		Process.ErrorMsg( "Invalid Request", ;
			"Sorry, your request was either invalid or has been lost. Please try again." )
		RETURN
	CASE m.lnStatus = -1  && cancel
		Process.ErrorMsg( "Request Cancelled","Your request has been cancelled." )
		RETURN
	CASE m.lnStatus = 1  && completed
		LOCAL lcResult, loReturnXML
		lcResult = loAsync.oEvent.ReturnData

		Response.Write( m.lcResult )
  
		RETURN
	ENDCASE
CASE m.lcAction == "Cancel"      
	loAsync.CancelEvent( m.lcJobId)
	Process.StandardPage( "Your request has been cancelled.")
	RETURN
ENDCASE

* If we get this far, we want to return a status update page:
lnTry = loAsync.oEvent.ChkCounter
IF m.lnTry > m.lnRetries
	Process.StandardPage( "Request Timeout", ;
		  "Sorry, but your request could not be completed in a timely fashion." + ;
		  " Please try again later.")
	RETURN
ENDIF
  
lcMessage = 'Please wait. Your request is being processed. <br>' + ;
	[<table cellpadding=0 cellspacing=0 style="border: medium solid orange;" width=] + TRANSFORM( 5 * m.lnRetries) + [>] + ;
	[<tr><td style="background-color: blue;"] + ;
	[ width=] + TRANSFORM( 5 * m.lnTry) + ;
	[>&nbsp;</td><td>&nbsp;</td></tr></table><br>] + ;
	loAsync.oEvent.Status
lcMessage = m.lcMessage + [<p align=center>] + ;
	Response.HREF( 'SlowTasks.ism?action=Cancel&JobId=' + m.lcJobId, "Cancel", .T.)
 
Process.StandardPage( "Asynchronous Task List", m.lcMessage, , m.lnRefreshPeriod, ;
	'SlowTasks.ism?action=Check&JobId=' + m.lcJobId )
